#include "n32g430.h"
#include "adc.h"

void ADC_init(void)
{
	  ADC_InitType ADC_InitStructure;
		GPIO_InitType GPIO_InitStructure;

    GPIO_Structure_Initialize(&GPIO_InitStructure);             //GPIOṹĳʼ
    /* ADCΪģ -------------------------*/
    GPIO_InitStructure.Pin       = GPIO_PIN_2 | GPIO_PIN_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_MODE_ANALOG;            //ģģʽ
    GPIO_Peripheral_Initialize(GPIOA, &GPIO_InitStructure);
    
    GPIO_InitStructure.Pin       = GPIO_PIN_12;
    GPIO_InitStructure.GPIO_Mode = GPIO_MODE_ANALOG;            //ģģʽ
    GPIO_Peripheral_Initialize(GPIOB, &GPIO_InitStructure);
	
	  ADC_Initializes_Structure(&ADC_InitStructure);
    ADC_InitStructure.MultiChEn      = ENABLE;                             //ͨģʽ
    ADC_InitStructure.ContinueConvEn = ENABLE;                             //ģʽ
    ADC_InitStructure.DatAlign       = ADC_DAT_ALIGN_R;                    //Ҷ
    ADC_InitStructure.ExtTrigSelect  = ADC_EXT_TRIGCONV_REGULAR_SWSTRRCH;  //Ƕת˼
    ADC_InitStructure.ChsNumber      = ADC_REGULAR_LEN_3;                  //ָʹöΪͨתADCͨ2
    ADC_Initializes(&ADC_InitStructure);
    
    /* ADCͨʱ */
    ADC_Channel_Sample_Time_Config(ADC_Channel_02_PA1, ADC_SAMP_TIME_55CYCLES5);
		ADC_Channel_Sample_Time_Config(ADC_Channel_03_PA2, ADC_SAMP_TIME_55CYCLES5);
		ADC_Channel_Sample_Time_Config(ADC_Channel_14_PB12, ADC_SAMP_TIME_55CYCLES5);
		
    /* ADCͨ */
    ADC_Regular_Sequence_Conversion_Number_Config(ADC_Channel_02_PA1, ADC_REGULAR_NUMBER_1);
		ADC_Regular_Sequence_Conversion_Number_Config(ADC_Channel_03_PA2, ADC_REGULAR_NUMBER_2);
		ADC_Regular_Sequence_Conversion_Number_Config(ADC_Channel_14_PB12, ADC_REGULAR_NUMBER_3); 
 
    /* ʹ ADC DMA ת */
    ADC_DMA_Transfer_Enable();

    /* ʹ ADC */
    ADC_ON();
    
    /* Check ADC Ready */
    while(ADC_Flag_Status_Get(ADC_RD_FLAG, ADC_FLAG_JENDCA, ADC_FLAG_RDY) == RESET);
    
    /* Start ADC1 calibration */               //ʼУ׼ADC1
    ADC_Calibration_Operation(ADC_CALIBRATION_ENABLE);
		
    /* Check the end of ADC1 calibration */    //ADC1У׼
    while (ADC_Calibration_Operation(ADC_CALIBRATION_STS)); 
		
    /* Start ADC Software Conversion */        //ADCת
    ADC_Regular_Channels_Software_Conversion_Operation(ADC_EXTRTRIG_SWSTRRCH_ENABLE);
}

