#include "n32g430.h"
#include "dma.h"

__IO uint16_t ADCConvertedValue;

void DMA_init(void)
{
    DMA_InitType DMA_InitStructure;
	/* DMA channel1 configuration ----------------------------------------------*/
    DMA_Reset(DMA_CH1);              //ܲDMAͨ1
    DMA_InitStructure.PeriphAddr     = (uint32_t)&ADC->DAT;           //DMAַ ADC
    DMA_InitStructure.MemAddr        = (uint32_t)&ADCConvertedValue;  //DMA洢ַ  Զ 
    DMA_InitStructure.Direction      = DMA_DIR_PERIPH_SRC;            //DMA___Դ  赽洢
    DMA_InitStructure.BufSize        = 3;                             //ݴ
    DMA_InitStructure.PeriphInc      = DMA_PERIPH_INC_MODE_DISABLE;   //ģʽ
    DMA_InitStructure.MemoryInc      = DMA_MEM_INC_MODE_ENABLE;       //洢ģʽ
    DMA_InitStructure.PeriphDataSize = DMA_PERIPH_DATA_WIDTH_HALFWORD;//ݳ   16λ
    DMA_InitStructure.MemDataSize    = DMA_MEM_DATA_WIDTH_HALFWORD;   //洢ݳ 16λ
    DMA_InitStructure.CircularMode   = DMA_CIRCULAR_MODE_ENABLE;      //ѭģʽ
    DMA_InitStructure.Priority       = DMA_CH_PRIORITY_HIGH;          //ȼ
    DMA_InitStructure.Mem2Mem        = DMA_MEM2MEM_DISABLE;           //ڴ浽ڴʹDMAͨ1
    DMA_Initializes(DMA_CH1, &DMA_InitStructure);                     //ʼDMAdͨ1
    DMA_Channel_Request_Remap(DMA_CH1, DMA_REMAP_ADC);                //DMAyuADCϵ
	
    /* Enable DMA channel1 */
    DMA_Channel_Enable(DMA_CH1);     //ʹDMAͨ1
}

